#include "component_fatness.h"

/* Sets fatness level. */
static void
_fatness_set(ComponentFatness* self, ECS* ecs)
{
	ComponentAnimationIdle* animationIdle;

	animationIdle = ecs_component_get(ecs, ECS_COMPONENT_ANIMATION_IDLE, self->component.id);

	animationIdle->baseIndex = animationIdle->baseIndex + 2;
	animationIdle->timerMax = animationIdle->timerMax * 2;

	sound_play(&ecs->game->resources.sounds[SOUND_GROW], SOUND_SPECIAL);
}

/* Initializes fatness component. */
void
component_fatness_init(ComponentFatness* self, u32* thresholds, u32 thresholdCount)
{
	self->thresholds = thresholds;
	self->thresholdCount = thresholdCount;
}

/* Ticks fatness component. */
void
component_fatness_tick(ComponentFatness* self, ECS* ecs)
{
	ComponentGoodies* goodies;

	goodies = ecs_component_get(ecs, ECS_COMPONENT_GOODIES, self->component.id);

	for (s32 i = 0; i < (s32)self->thresholdCount; i++)
	{
		if 
		(
			goodies->value >= self->thresholds[i] &&
			(s32)self->previousValue < i
		)
		{
			self->value = i;
			_fatness_set(self, ecs);
		}
	}


	self->previousValue = self->value;
}
